package manas.GGates;

import org.jgraph.graph.*;
import org.jgraph.JGraph;

import javax.swing.tree.MutableTreeNode;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.util.Map;
import java.util.Hashtable;

import manas.gui.DesignFrame;
import manas.MGates.MWire;

/**
 * Created by IntelliJ IDEA.
 * User: root
 * Date: 28.May.2006
 * Time: 12:42:22
 * To change this template use File | Settings | File Templates.
 */
public class GClock extends DefaultGraphCell implements Runnable, Simulation {
    JGraph graph;
    GraphModel model;
    private MWire outWire;
    private int state = 0;
//    private Thread thisThread = Thread.currentThread();
    private Thread t;
    private volatile Thread blinker;

    public boolean isActive() {
        return isActive;
    }

    public void setActive(boolean active) {
        isActive = active;
        if(isActive) {
            t = new Thread(this);
            t.start();
        }
        else t.stop();
    }

    private boolean isActive = false;

    public GClock(JGraph graph) {
        this.graph = graph;
        model = graph.getModel();
        init();
    }

    public GClock(Object userObject) {
        super(userObject);
        init();
    }

    public GClock(Object userObject, AttributeMap storageMap) {
        super(userObject, storageMap);
        init();
    }

    public GClock(Object userObject, AttributeMap storageMap, MutableTreeNode[] children) {
        super(userObject, storageMap, children);
        init();
    }

     protected static ImageIcon CreateImageIcon(String path) {
            java.net.URL imgURL = DesignFrame.class.getResource(path);
            if (imgURL != null) {
                return new ImageIcon(imgURL);
            } else {
                System.err.println("Couldn't find file: " + path);
                    return null;
            }
        }

    public Map createCellAttributes(Point2D point, String path)
        {
            Map map = new Hashtable();
            ImageIcon icon = null;
/*    String iconPath = "images/andgate_small.gif";
    URL jgraphUrl = MainFrame.class.getClassLoader()
                            .getResource(iconPath);
    if(jgraphUrl == null) System.out.println("icon yok");
    icon = new ImageIcon(jgraphUrl);*/
            icon = CreateImageIcon(path);
            GraphConstants.setBounds(map, new Rectangle2D.Double(point.getX(), point.getY(), 20, 20));
            GraphConstants.setResize(map, true);
            GraphConstants.setSizeable(map, false);
            GraphConstants.setSelectable(map, true);
            GraphConstants.setEditable(map, false);
            GraphConstants.setIcon(map, icon);
            return map;
            }


    private void init()
    {
        getAttributes().applyMap(createCellAttributes(new Point(10, 10),"images/clock1.gif"));
        OutPort op = new OutPort();
        GraphConstants.setOffset(op.getAttributes(), new Point(1000, 500));
        this.add(op);

        outWire = new MWire();
        outWire.addWire(state);

        /*
        Graphics2D graphics2D = (Graphics2D) this.graph.getGraphics();
        CellViewFactory cvf = new DefaultCellViewFactory();
        CellView cw = cvf.createView(this.model, this);
//        System.out.println("CellView size = " + cw.length);
//        if(cw.length <= 0) return;
        graphics2D.drawOval(0, 0, 20, 30);
        graph.getUI().paintCell(graphics2D, cw, new Rectangle2D.Double(30, 30, 50, 50), true);
        */

    }

    public int changeState()
    {
        int ret;
        ImageIcon icon = null;

        ret = Math.abs(state - 1);
        state = ret;
        System.out.println(ret);
        if(ret == 0) icon = CreateImageIcon("images/clock1.gif");
        else icon = CreateImageIcon("images/clock2.gif");
        GraphConstants.setIcon(this.getAttributes(), icon);
        CellView cell = graph.getGraphLayoutCache().getMapping(this, true);
        Rectangle2D bounds = GraphConstants.getBounds(this.getAttributes());
        graph.getUI().paintCell(graph.getGraphics(), cell, bounds, true);
        graph.getGraphLayoutCache().refresh(graph.getGraphLayoutCache().getCellViews(), true);
        graph.repaint();
        System.out.println("Clock = " + ret);
        return ret;
    }

    public void run() {
        //To change body of implemented methods use File | Settings | File Templates.
//        Thread thisThread = Thread.currentThread();
        System.out.println("Clock thread calisti ----");
        while(true)
        {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e){
            }

            changeState();
        }

    }

    public MWire simulate() {
        outWire.setwire(0, state);

        return outWire;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire1(MWire inWire1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setInWire2(MWire inWire2) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire getOutWire() {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public boolean isVisited() {
        return false;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setVisited(boolean visited) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void push(int index, MWire deger) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public MWire pop(int index) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }
}
