package manas.event;

import org.jgraph.graph.*;
import org.jgraph.JGraph;

/**
 * Created by IntelliJ IDEA.
 * User: pc
 * Date: 23.Nis.2006
 * Time: 00:23:25
 * To change this template use File | Settings | File Templates.
 */
public  class MyGraph extends JGraph {

                // Construct the Graph using the Model as its Data Source
                public MyGraph(GraphModel model) {
                        this(model, null);
                }

                // Construct the Graph using the Model as its Data Source
                public MyGraph(GraphModel model, GraphLayoutCache cache) {
                        super(model, cache);
                        // Make Ports Visible by Default
                        setPortsVisible(true);
                        // Use the Grid (but don't make it Visible)
                        setGridEnabled(true);
                        // Set the Grid Size to 10 Pixel
                        setGridSize(6);
                        // Set the Tolerance to 2 Pixel
                        setTolerance(2);
                        // Accept edits if click on background
                        setInvokesStopCellEditing(true);
                        // Allows control-drag
                        setCloneable(true);
                        // Jump to default port on connect
                        setJumpToDefaultPort(true);
                }

                // Override Superclass Method to Return Custom EdgeView
                protected EdgeView createEdgeView(Object cell) {

                        // Return Custom EdgeView
                        return new EdgeView(cell) {

                                /**
                                 * Returns a cell handle for the view.
                                 */
                                public CellHandle getHandle(GraphContext context) {
                                        return new MyEdgeHandle(this, context);
                                }

                        };
                }
        }
