package manas.event;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.FileInputStream;
import java.io.DataInputStream;
import javax.swing.filechooser.*;
import org.w3c.dom.*;
import org.apache.xerces.parsers.DOMParser;
import org.jgraph.JGraph;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import java.lang.Character;
import java.util.List;
import java.util.ArrayList;
import manas.GGates.*;


/**
 * Created by IntelliJ IDEA.
 * User: Serhat
 * Date: 29.Oca.2006
 * Time: 15:33:04
 * To change this template use File | Settings | File Templates.
 */
public class OpenDrawAction extends AbstractAction {
    private JGraph   designInternalFrame1 ;

    public OpenDrawAction(JGraph designInternalFrame) {

        this.designInternalFrame1 = designInternalFrame;

    }

    public void actionPerformed(ActionEvent e) {
      try{

        JFileChooser chooser = new JFileChooser();
        FileFilter filter = new FileFilter() {
            public boolean accept(File f) {
                        return f.isDirectory() || f.getName().toLowerCase().endsWith(".xml")
                                               || f.getName().toLowerCase().endsWith(".lgf");
                    }
            public String getDescription() {
                        return "XML or LGF file";
                    }
        };

        chooser.setFileFilter(filter);

        int returnVal = chooser.showOpenDialog(null);
        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
          String path = chooser.getSelectedFile().getAbsolutePath();
          FileInputStream fos = new FileInputStream(path);

//READ XML
          if(path.charAt(path.length()-1) == 'l')
          {
            DOMParser parser = new DOMParser();
            parser.parse(path);
            Document doc = parser.getDocument();

            Node attrNode;
   //Vertex attributes
            NodeList nodeListVertex = doc.getElementsByTagName("VERTEX");
            int vertexCount = nodeListVertex.getLength();

            int[] ID = new int[vertexCount];         //id of vertex
            String[] TYPE = new String[vertexCount]; //type of vertex
            double[] X = new double[vertexCount];    //x coordinate of vertex
            double[] Y = new double[vertexCount];    //y coordinate of vertex
            int[] PORT = new int[vertexCount];       //port number of vertex

            for(int i = 0; i < vertexCount ; i++)
            {
                Node nod = nodeListVertex.item(i);
                NamedNodeMap map = nod.getAttributes();    //TODO nod.hasAttributes() ile kontrol et (Serhat)
                attrNode = map.getNamedItem("ID");
                ID[i] = Integer.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("TYPE");
                TYPE[i] = attrNode.getNodeValue();
                attrNode = map.getNamedItem("X");
                X[i] = Double.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("Y");
                Y[i] = Double.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("PORT");
                PORT[i] = Integer.valueOf(attrNode.getNodeValue());
            }

   //Edge attributes
            NodeList nodeListEdge = doc.getElementsByTagName("EDGE");
            int edgeCount = nodeListEdge.getLength();

            int[] IDe = new int[edgeCount];    //edge id
            int[] IDs = new int[edgeCount];    //source vertex id
            int[] IDt = new int[edgeCount];    //target vertex id
            int[] Ps = new int[edgeCount];     //port number of the source port
            int[] Pt = new int[edgeCount];     //port number of the target port

            for(int i = 0; i < edgeCount ; i++)
            {
                Node nod = nodeListEdge.item(i);
                NamedNodeMap map = nod.getAttributes();
                attrNode = map.getNamedItem("ID");
                IDe[i] = Integer.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("SOURCE_VERTEX_ID");
                IDs[i] = Integer.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("TARGET_VERTEX_ID");
                IDt[i] = Integer.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("SOURCE_PORT_NUMBER");
                Ps[i] = Integer.valueOf(attrNode.getNodeValue());
                attrNode = map.getNamedItem("TARGET_PORT_NUMBER");
                Pt[i] = Integer.valueOf(attrNode.getNodeValue());
            }

            DefaultEdge[] edges = new  DefaultEdge[edgeCount];
            DefaultGraphCell[] Vertices = new DefaultGraphCell[vertexCount];

      //LOAD TO CANVAS
         //vertex load
            for(int i = 0 ; i < vertexCount ; i++)
            {
                if(TYPE[i].equals("GAnd"))
                {
                    GAnd cell = new GAnd(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GOr"))
                {
                    GOr cell = new GOr(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GNand"))
                {
                    GNand cell = new GNand(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GNor"))
                {
                    GNor cell = new GNor(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GXor"))
                {
                    GXor cell = new GXor(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GNot"))
                {
                    GNot cell = new GNot(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GSwitch"))
                {
                    GSwitch cell = new GSwitch();
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE[i].equals("GLed"))
                {
                    GLed cell = new GLed(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(X[i],Y[i],40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
            }

         //edge load
            for(int i = 0; i < edgeCount ; i++)
            {
                edges[i] = new DefaultEdge();
                GraphConstants.setRouting(edges[i].getAttributes(), GraphConstants.ROUTING_SIMPLE);
                GraphConstants.setLineStyle(edges[i].getAttributes(), GraphConstants.STYLE_ORTHOGONAL);
                edges[i].setSource(Vertices[IDs[i]].getChildAt(Ps[i]));
                edges[i].setTarget(Vertices[IDt[i]].getChildAt(Pt[i]));
                designInternalFrame1.getGraphLayoutCache().insert(edges[i]);
            }
          }
//READ LGF
          else if(path.charAt(path.length()-1) == 'f')
          {
              List<String> TYPE = new ArrayList<String>();   //type of vertex
              int[] X = new int[200];      //x coordinate of vertex
              int[] Y = new int[200];      //y coordinate of vertex
              List<int[]> PORT = new ArrayList<int[]>();   //ports of vertex

              //FileInputStream fos = new FileInputStream(path);
              DataInputStream in = new DataInputStream(fos);
//TODO convert "String readLine()" to "String BufferedReader.readLine()"  (Serhat)
              int index = 0;
              while (in.available() !=0)
              {
                  String line = in.readLine();
                  if(line.length() >= 2)
                  {
                      if(Character.isUpperCase(line.charAt(0)))
                      {
                          if(line.charAt(0) == 'A' && line.charAt(1) == 'N' && line.charAt(2) == 'D')
                          {
                              TYPE.add("GAnd");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [4];
                              ports[0] = 3;
                              ports[1] = line.charAt(0) - 48 ;  //inPort1
                              ports[2] = line.charAt(2) - 48 ;  //inPort2
                              ports[3] = line.charAt(4) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'I' && line.charAt(1) == 'N' && line.charAt(2) == 'V')
                          {
                              TYPE.add("GNot");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [3];
                              ports[0] = 2;
                              ports[1] = line.charAt(0) - 48;  //inPort
                              ports[2] = line.charAt(2) - 48;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'O' && line.charAt(1) == 'R')
                          {
                              TYPE.add("GOr");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [4];
                              ports[0] = 3;
                              ports[1] = line.charAt(0) - 48 ;  //inPort1
                              ports[2] = line.charAt(2) - 48 ;  //inPort2
                              ports[3] = line.charAt(4) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'N' && line.charAt(1) == 'A' && line.charAt(2) == 'N')
                          {
                              TYPE.add("GNand");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [4];
                              ports[0] = 3;
                              ports[1] = line.charAt(0) - 48 ;  //inPort1
                              ports[2] = line.charAt(2) - 48 ;  //inPort2
                              ports[3] = line.charAt(4) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'N' && line.charAt(1) == 'O' && line.charAt(2) == 'R')
                          {
                              TYPE.add("GNor");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [4];
                              ports[0] = 3;
                              ports[1] = line.charAt(0) - 48 ;  //inPort1
                              ports[2] = line.charAt(2) - 48 ;  //inPort2
                              ports[3] = line.charAt(4) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'S' && line.charAt(1) == 'W' && line.charAt(2) == 'I')
                          {
                              TYPE.add("GSwitch");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [2];
                              ports[0] = 1;
                              ports[1] = line.charAt(0) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'L' && line.charAt(1) == 'E' && line.charAt(2) == 'D')
                          {
                              TYPE.add("GLed");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [2];
                              ports[0] = 1;
                              ports[1] = line.charAt(0) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          else if(line.charAt(0) == 'X' && line.charAt(1) == 'O' && line.charAt(2) == 'R')
                          {
                              TYPE.add("GXor");
                              line = in.readLine();
                              X[index] = (line.charAt(0) - 48)*1000 + (line.charAt(1) - 48)*100
                                           + (line.charAt(2) - 48)*10 + (line.charAt(3) - 48);
                              Y[index] = (line.charAt(5) - 48)*1000 + (line.charAt(6) - 48)*100
                                           + (line.charAt(7) - 48)*10 + (line.charAt(8) - 48);
                              line = in.readLine();
                              int[] ports = new int [4];
                              ports[0] = 3;
                              ports[1] = line.charAt(0) - 48 ;  //inPort1
                              ports[2] = line.charAt(2) - 48 ;  //inPort2
                              ports[3] = line.charAt(4) - 48 ;  //outPort
                              PORT.add(ports);
                          }
                          index++;
                      }
                  }
              }

            int vertexCount = TYPE.size();
            DefaultGraphCell[] Vertices = new DefaultGraphCell[vertexCount];
     //LOAD TO CANVAS
         //vertex load
            for(int i = 0 ; i < vertexCount ; i++)
            {
                if(TYPE.get(i).equals("GAnd"))
                {
                    GAnd cell = new GAnd(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GOr"))
                {
                    GOr cell = new GOr(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GNand"))
                {
                    GNand cell = new GNand(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GNor"))
                {
                    GNor cell = new GNor(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GXor"))
                {
                    GXor cell = new GXor(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GNot"))
                {
                    GNot cell = new GNot(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GSwitch"))
                {
                    GSwitch cell = new GSwitch();
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
                else if(TYPE.get(i).equals("GLed"))
                {
                    GLed cell = new GLed(designInternalFrame1);
                    Vertices[i] = cell;
                    GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double((X[i]-3275)*8,(Y[i]-3275)*8,40,20));
                    designInternalFrame1.getGraphLayoutCache().insert(cell);
                }
            }

        //edge load
            //find source and targets of edges ( bu segment anneler gunu dolay�s�yla anname gitsin :D )(Serhat)
            for(int i = 0; i < vertexCount ; i++)
            {
                for(int j = 0; j < (PORT.get(i))[0] ; j++)
                {
                    int control = (PORT.get(i))[j+1];

                    for(int m = 0; m < vertexCount ; m++)
                    {
                        for(int n = 0; n < (PORT.get(m))[0] ; n++)
                        {
                            if((control == (PORT.get(m))[n+1]) && (m!=i || n!=j))
                            {
                            //    if(n > j)
                                {
                                    DefaultEdge edge = new DefaultEdge();
                                    GraphConstants.setRouting(edge.getAttributes(), GraphConstants.ROUTING_SIMPLE);
                                    GraphConstants.setLineStyle(edge.getAttributes(), GraphConstants.STYLE_ORTHOGONAL);
                                    edge.setSource(Vertices[i].getChildAt(j));
                                    edge.setTarget(Vertices[m].getChildAt(n));
                                    designInternalFrame1.getGraphLayoutCache().insert(edge);
                                }
                            }
                        }
                    }
                }
            }
            in.close();
          }
          fos.close();
        }

      } catch ( Exception ex ) {
                    ex.printStackTrace();
      }
    }
}
