package manas.gui;

import org.jgraph.JGraph;
import org.jgraph.graph.*;

import java.awt.event.MouseEvent;

/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:15:55
 * To change this template use File | Settings | File Templates.
 */
public class DesignPanel extends JGraph {

    public DesignPanel(GraphModel model) {
        this(model, null);
    }

    public DesignPanel(GraphModel model, GraphLayoutCache cache) {
        super(model, cache);
        // Make Ports Visible by Default
        setPortsVisible(true);
        // Use the Grid (but don't make it Visible)
        setGridEnabled(true);
        // Set the Grid Size to 10 Pixel
        setGridSize(6);
        // Set the Tolerance to 2 Pixel
        setTolerance(2);
        // Accept edits if click on background
        setInvokesStopCellEditing(true);
        // Allows control-drag
        setCloneable(true);
        // Jump to default port on connect
        setJumpToDefaultPort(true);
    }

            protected EdgeView createEdgeView(Object cell) {

            // Return Custom EdgeView
            return new EdgeView(cell) {

                /**
                 * Returns a cell handle for the view.
                 */
                public CellHandle getHandle(GraphContext context) {
                    return new MyEdgeHandle(this, context);
                }

            };
        }

    //
    // Custom Edge Handle
    //

    // Defines a EdgeHandle that uses the Shift-Button (Instead of the Right
    // Mouse Button, which is Default) to add/remove point to/from an edge.
    public static class MyEdgeHandle extends EdgeView.EdgeHandle {

        /**
         * @param edge
         * @param ctx
         */
        public MyEdgeHandle(EdgeView edge, GraphContext ctx) {
            super(edge, ctx);
        }

        // Override Superclass Method
        public boolean isAddPointEvent(MouseEvent event) {
            // Points are Added using Shift-Click
            return event.isShiftDown();
        }

        // Override Superclass Method
        public boolean isRemovePointEvent(MouseEvent event) {
            // Points are Removed using Shift-Click
            return event.isShiftDown();
        }

    }
}
