package manas.gui;

import manas.event.*;
import java.awt.*;
import java.net.URL;
import javax.swing.*;
import javax.swing.border.*;

import org.jgraph.JGraph;


/**
 * Created by IntelliJ IDEA.
 * User: EV
 * Date: 29.Oca.2006
 * Time: 15:17:14
 * To change this template use File | Settings | File Templates.
 */
public class DesignToolBar extends JToolBar {
    JGraph graph1;

    // Actions
//    AddAndAction addAndAction = new AddAndAction();
    //and of actions

    ImageIcon[] images, toolbarIcons;
    ImageIcon iconPath;
    JButton buton[] = new JButton[10];
    JButton toolButon[] = new JButton[20];
    private JButton newDrawMenuItem;
    private JButton openDrawMenuItem;
    private JButton saveDrawMenuItem;
    private JButton printDrawMenuItem;
    private JButton cutDrawMenuItem;
    private JButton copyDrawMenuItem;
    private JButton pasteDrawMenuItem;
    private JButton deleteDrawMenuItem;
    private JButton zomInDrawMenuItem;
    private JButton zomOutDrawMenuItem;
    private JButton addAndButton;
    private JButton addOrButton;
    private JButton addNotButton;
    private JButton addNandButton;
    private JButton addNorButton;
    private JButton addXorButton;
    private JButton addClockButton;
    private JButton addLedButton;
    private JButton addWireButton;
    private JButton groupButton;
    private JButton ungroupButton;
    private JButton addSwitchButton;
//    private JButton simulationStart;


    protected static ImageIcon CreateImageIcon(String path) {
        java.net.URL imgURL = DesignFrame.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
                return null;
        }
    }

    public DesignToolBar(JGraph graph) {
        this.graph1 = graph;
        BoxLayout boxLayout;
        Container myPane = new Container();
        JToolBar jToolBar = new JToolBar();
        JToolBar toolPanel = new JToolBar();
        boxLayout= new BoxLayout(myPane, BoxLayout.LINE_AXIS);
        myPane.setLayout(boxLayout);
        myPane.add(toolPanel);
        myPane.add(jToolBar);

        Insets margins = new Insets(5, 5, 10, 10);

        // Create Buttons
        newDrawMenuItem = new JButton(new NewDrawAction());
        openDrawMenuItem = new JButton(new OpenDrawAction(graph1));
        saveDrawMenuItem = new JButton(new SaveDrawAction(graph1));
        printDrawMenuItem = new JButton(new PrintDrawAction(graph1));
        cutDrawMenuItem = new JButton(new CutDrawAction(graph1));
        //Action copyDrawAction = javax.swing.TransferHandler.getCopyAction();
        copyDrawMenuItem = new JButton(new CopyDrawAction(graph1));

        pasteDrawMenuItem = new JButton(new PasteDrawAction(graph1));
        deleteDrawMenuItem = new JButton(new DeleteDrawAction(graph1));
        zomInDrawMenuItem = new JButton(new ZoomInDrawAction());
        zomOutDrawMenuItem = new JButton(new ZoomOutDrawAction());
        groupButton = new JButton(new GroupAction());
        ungroupButton = new JButton(new UngroupAction());
        addAndButton = new JButton(new AddAndAction(graph1));
        addOrButton = new JButton(new AddOrAction(graph1));
        addNotButton = new JButton(new AddNotAction(graph1));
        addNandButton = new JButton(new AddNandAction(graph1));
        addNorButton = new JButton(new AddNorAction(graph1));
        addClockButton = new JButton(new AddClockAction(graph1));
        addXorButton = new JButton(new AddXorAction(graph1));
        addLedButton = new JButton(new AddLedAction(graph1));
        addWireButton = new JButton(new AddWireAction());

        addSwitchButton = new JButton(new AddSwitchAction(graph1));

//        simulationStart    =  new JButton(">>");



        images = new ImageIcon[10];
        images[0] = CreateImageIcon("images/andgate_small.gif");
        images[1] = CreateImageIcon("images/orgate_small.gif");
        images[2] = CreateImageIcon("images/notgate_small.gif");
        images[3] = CreateImageIcon("images/nandgate_small.gif");
        images[4] = CreateImageIcon("images/norgate_small.gif");
        images[5] = CreateImageIcon("images/XORGATE_small.gif");
        images[6] = CreateImageIcon("images/wire_small.gif");
        images[7] = CreateImageIcon("images/led_small.gif");
        images[8] = CreateImageIcon("images/switch_small.gif");
        images[9] = CreateImageIcon("images/clock_small1.gif");

        toolbarIcons = new ImageIcon[20];
        toolbarIcons[0] = CreateImageIcon("images/toolbar/new_sm.gif");
        toolbarIcons[1] = CreateImageIcon("images/toolbar/open_sm.gif");
        toolbarIcons[2] = CreateImageIcon("images/toolbar/save_sm.gif");
        toolbarIcons[3] = CreateImageIcon("images/toolbar/print_sm.gif");
        toolbarIcons[4] = CreateImageIcon("images/toolbar/cut.gif");
        toolbarIcons[5] = CreateImageIcon("images/toolbar/copy.gif");
        toolbarIcons[6] = CreateImageIcon("images/toolbar/paste.gif");
        toolbarIcons[7] = CreateImageIcon("images/toolbar/delete.gif");
        toolbarIcons[8] = CreateImageIcon("images/toolbar/zoomin.gif");
        toolbarIcons[9] = CreateImageIcon("images/toolbar/zoomout.gif");
        toolbarIcons[10] = CreateImageIcon("images/toolbar/group.gif");
        toolbarIcons[11] = CreateImageIcon("images/toolbar/ungroup.gif");


        //   set icons
        newDrawMenuItem.setIcon(toolbarIcons[0]);
        openDrawMenuItem.setIcon(toolbarIcons[1]);
        saveDrawMenuItem.setIcon(toolbarIcons[2]);
        printDrawMenuItem.setIcon(toolbarIcons[3]);
        cutDrawMenuItem.setIcon(toolbarIcons[4]);
       copyDrawMenuItem.setIcon(toolbarIcons[5]);
       pasteDrawMenuItem.setIcon(toolbarIcons[6]);


        deleteDrawMenuItem.setIcon(toolbarIcons[7]);
        zomInDrawMenuItem.setIcon(toolbarIcons[8]);
        zomOutDrawMenuItem.setIcon(toolbarIcons[9]);
        groupButton.setIcon(toolbarIcons[10]);
        ungroupButton.setIcon(toolbarIcons[11]);
        addAndButton.setIcon(images[0]);
        addOrButton.setIcon(images[1]);
        addNotButton.setIcon(images[2]);
        addNandButton.setIcon(images[3]);
        addNorButton.setIcon(images[4]);
        addXorButton.setIcon(images[5]);
        addWireButton.setIcon(images[6]);
        addLedButton.setIcon(images[7]);
        addSwitchButton.setIcon(images[8]);
        addClockButton.setIcon(images[9]);


        //      Add buttons
        newDrawMenuItem.setMargin(margins);
        this.add(newDrawMenuItem);

        openDrawMenuItem.setMargin(margins);
        this.add(openDrawMenuItem);

        saveDrawMenuItem.setMargin(margins);
        this.add(saveDrawMenuItem);

        printDrawMenuItem.setMargin(margins);
        this.add(printDrawMenuItem);

        cutDrawMenuItem.setMargin(margins);
        this.add(cutDrawMenuItem);



       copyDrawMenuItem.setMargin(margins);
       this.add(copyDrawMenuItem);

        pasteDrawMenuItem.setMargin(margins);
        this.add(pasteDrawMenuItem);

        deleteDrawMenuItem.setMargin(margins);
        this.add(deleteDrawMenuItem);

        zomInDrawMenuItem.setMargin(margins);
        this.add(zomInDrawMenuItem);

        zomOutDrawMenuItem.setMargin(margins);
        this.add(zomOutDrawMenuItem);

        groupButton.setMargin(margins);
        this.add(groupButton);

        ungroupButton.setMargin(margins);
        this.add(ungroupButton);

        addAndButton.setMargin(margins);
        this.add(addAndButton);

        addOrButton.setMargin(margins);
         this.add(addOrButton);

        addNotButton.setMargin(margins);
        this.add(addNotButton);

        addNandButton.setMargin(margins);
        this.add(addNandButton);

        addNorButton.setMargin(margins);
        this.add(addNorButton);

        addXorButton.setMargin(margins);
        this.add(addXorButton);

        addLedButton.setMargin(margins);
        this.add(addLedButton);

        addSwitchButton.setMargin(margins);
        this.add(addSwitchButton);

        addClockButton.setMargin(margins);
        this.add(addClockButton);

        addWireButton.setMargin(margins);
         this.add(addWireButton);

//        simulationStart.setMargin(margins);
//        this.add(simulationStart);



        this.setBorder(new BevelBorder(BevelBorder.RAISED));

        setVisible(true);

    }
}
