package manas.simulation;

import manas.MGates.MSuper;

import java.util.Vector;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

import org.jgraph.JGraph;
import org.jgraph.graph.GraphModel;
import org.jgraph.graph.DefaultEdge;

/**
 * Created by IntelliJ IDEA.
 * User: SahinBey
 * Date: 27.Nis.2006
 * Time: 22:56:53
 * To change this template use File | Settings | File Templates.
 */
public class CircuitSplitter {
    Vector<Integer> subCircuitIndex;
    Vector <int[]> subCircuiits;
    Vector<Object> elementList;
    Vector<Object> mainList;
    Vector<Object> edgeList;
    /*Vector<MSuper> maincircuit;
    Vector<MSuper> subCircuit;
    Vector<Vector<MSuper>> allSubCircuits;
    */
    JGraph graph;
    GraphModel model;

    public CircuitSplitter(JGraph graph) {
        this.graph = graph;
        this.model = graph.getModel();
        this.subCircuiits = new Vector<int[]>();
        this.subCircuitIndex = new Vector<Integer>();
        this.elementList = new Vector<Object>();
        this.mainList = new Vector<Object>();
        this.edgeList = new Vector<Object>();

    }

    private void extractOneCircuit(Object node)
    {
        if(node == null) return;
        if(model.isEdge(node)) {
            //extractOneCircuit(((DefaultEdge)node).getSource());
            extractOneCircuit(model.getParent(model.getSource(node)));
            //extractOneCircuit(((DefaultEdge)node).getTarget());
            extractOneCircuit(model.getParent(model.getTarget(node)));
            this.edgeList.addElement(node);
            this.mainList.remove(node);
            //System.out.println("edge *********");
        } else if(this.elementList.contains(node) == false) {
            //System.out.println("vertex ------");

            this.mainList.remove(node);
            this.elementList.add(node);
            this.subCircuitIndex.add(this.model.getIndexOfRoot(node));

            int numChildren = model.getChildCount(node);
            for (int i = 0; i < numChildren; i++) {
                Object port = model.getChild(node, i);
                if(model.isPort(port)) {
                    Iterator iter = model.edges(port);
                    while(iter.hasNext())
                        extractOneCircuit(iter.next());
                }
            }

        }
    }

    public Vector <int[]> extractAllCircuits()
    {
        Vector <int[]> totalElements = new Vector<int[]>();
        int rc = model.getRootCount();

        mainList.clear();
        for(int i = 0; i < rc; i++)
        {
            mainList.add(model.getRootAt(i));
            //System.out.println("root ald " + i);
        }
        while(mainList.isEmpty() == false)
        {
            if(isAllEdge(mainList)) break;
            //System.out.println("dn");
            extractOneCircuit(this.mainList.elementAt(0));
            int mal[] = new int[this.subCircuitIndex.size()];
            for(int i = 0; i < this.subCircuitIndex.size(); i++)
                mal[i] = this.subCircuitIndex.get(i);
            totalElements.add(mal);
            this.elementList.clear();
            this.subCircuitIndex.clear();
        }
        return totalElements;
    }

    private boolean isAllEdge(Vector<Object> liste)
    {
        int i;
        for (i = 0; i < liste.size(); i++) {
            if(model.isEdge(liste.elementAt(i)) == false) break;
        }

        return ((i == liste.size())?true:false);
    }

}
